"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LinkDrawer = void 0;
const react_1 = __importDefault(require("react"));
const react_i18next_1 = require("react-i18next");
const Drawer_1 = require("../../../../../../elements/Drawer");
const Button_1 = __importDefault(require("../../../../../../elements/Button"));
const X_1 = __importDefault(require("../../../../../../icons/X"));
const Form_1 = __importDefault(require("../../../../../Form"));
const Submit_1 = __importDefault(require("../../../../../Submit"));
const __1 = __importDefault(require("../../../.."));
const RenderFields_1 = __importDefault(require("../../../../../RenderFields"));
require("./index.scss");
const Gutter_1 = require("../../../../../../elements/Gutter");
const baseClass = 'rich-text-link-edit-modal';
const LinkDrawer = ({ handleClose, handleModalSubmit, initialState, fieldSchema, drawerSlug, }) => {
    const { t } = (0, react_i18next_1.useTranslation)('fields');
    return (react_1.default.createElement(Drawer_1.Drawer, { slug: drawerSlug, formatSlug: false, className: baseClass },
        react_1.default.createElement(Gutter_1.Gutter, { className: `${baseClass}__template` },
            react_1.default.createElement("header", { className: `${baseClass}__header` },
                react_1.default.createElement("h2", { className: `${baseClass}__header-text` }, t('editLink')),
                react_1.default.createElement(Button_1.default, { className: `${baseClass}__header-close`, buttonStyle: "none", onClick: handleClose },
                    react_1.default.createElement(X_1.default, null))),
            react_1.default.createElement(Form_1.default, { onSubmit: handleModalSubmit, initialState: initialState },
                react_1.default.createElement(RenderFields_1.default, { fieldTypes: __1.default, readOnly: false, fieldSchema: fieldSchema, forceRender: true }),
                react_1.default.createElement(Submit_1.default, null, t('general:submit'))))));
};
exports.LinkDrawer = LinkDrawer;
//# sourceMappingURL=index.js.map