import { Response } from 'express';
import { Config as GeneratedTypes } from 'payload/generated-types';
import { PayloadRequest } from '../../express/types';
import { Collection, TypeWithID } from '../../collections/config/types';
export type Arguments = {
    collection: Collection;
    data: Omit<TypeWithID, 'id'> & {
        email: string;
        password: string;
    };
    req: PayloadRequest;
    res: Response;
};
export type Result<T> = {
    message: string;
    user: T;
};
declare function registerFirstUser<TSlug extends keyof GeneratedTypes['collections']>(args: Arguments): Promise<Result<GeneratedTypes['collections'][TSlug]>>;
export default registerFirstUser;
