"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const logger_1 = __importDefault(require("../utilities/logger"));
async function sendEmail(message) {
    let result;
    try {
        const email = await this.email;
        result = email.transport.sendMail(message);
    }
    catch (err) {
        logger_1.default.error(`Failed to send mail to ${message.to}, subject: ${message.subject}`, err);
        return err;
    }
    return result;
}
exports.default = sendEmail;
//# sourceMappingURL=sendEmail.js.map