"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.enforceMaxVersions = void 0;
const enforceMaxVersions = async ({ payload, Model, max, slug, entityType, id, }) => {
    var _a;
    try {
        const query = {};
        if (id)
            query.parent = id;
        const oldestAllowedDoc = await Model.find(query).limit(1).skip(max).sort({ createdAt: -1 });
        if ((_a = oldestAllowedDoc === null || oldestAllowedDoc === void 0 ? void 0 : oldestAllowedDoc[0]) === null || _a === void 0 ? void 0 : _a.createdAt) {
            const deleteLessThan = oldestAllowedDoc[0].createdAt;
            await Model.deleteMany({
                createdAt: {
                    $lte: deleteLessThan,
                },
            });
        }
    }
    catch (err) {
        payload.logger.error(`There was an error cleaning up old versions for the ${entityType} ${slug}`);
    }
};
exports.enforceMaxVersions = enforceMaxVersions;
//# sourceMappingURL=enforceMaxVersions.js.map