"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getLatestCollectionVersion = void 0;
const getLatestCollectionVersion = async ({ payload, collection: { config, Model, }, query, id, lean = true, }) => {
    var _a;
    let version;
    if ((_a = config.versions) === null || _a === void 0 ? void 0 : _a.drafts) {
        version = payload.versions[config.slug].findOne({
            parent: id,
        }, {}, {
            sort: { updatedAt: 'desc' },
            lean,
        });
    }
    const collection = await Model.findOne(query, {}, { lean });
    version = await version;
    if (!version || version.updatedAt < collection.updatedAt) {
        collection.id = collection._id;
        return collection;
    }
    return {
        ...version.version,
        id,
        updatedAt: version.updatedAt,
        createdAt: version.createdAt,
    };
};
exports.getLatestCollectionVersion = getLatestCollectionVersion;
//# sourceMappingURL=getLatestCollectionVersion.js.map